unit main;

interface

uses
  Windows, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, DXDraws,
  StdCtrls, DXClass, vektors, Buttons, DXSounds, DXPlay, startf, spiel;

type
  TForm1 = class(TForm)
    DXDraw1: TDXDraw;
    ImageList: TDXImageList;
    Button1: TButton;
    DXTimer1: TDXTimer;
    Button2: TButton;
    SpeedButton1: TSpeedButton;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    CheckBox1: TCheckBox;
    DXSound1: TDXSound;
    DXWaveList1: TDXWaveList;
    Label7: TLabel;
    Label8: TLabel;
    DXPlay1: TDXPlay;
    ListBox1: TListBox;
    Button3: TButton;
    Memo1: TMemo;
    Button4: TButton;
    ListBox2: TListBox;
    Label11: TLabel;
    Label12: TLabel;
    Label9: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure DXTimer1Timer(Sender: TObject; LagCount: Integer);
    procedure DXDraw1MouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure DXDraw1MouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure Button2Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure DXPlay1Open(Sender: TObject);
    procedure DXPlay1AddPlayer(Sender: TObject; _Player: TDXPlayPlayer);
    procedure DXPlay1DeletePlayer(Sender: TObject; _Player: TDXPlayPlayer);
    procedure DXPlay1Message(Sender: TObject; From: TDXPlayPlayer; Data: Pointer; DataSize: Integer);
    procedure ki(plnr: integer);
    procedure start;
    procedure draw;
    procedure Button4Click(Sender: TObject);
    procedure sendereignis(typ,_time:integer;ve:TVektor);
    procedure pingit;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;


implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
var int1 : integer;
begin
  kkugel := addr(kugeln[-1]);
  kkugel^.radius := 25;
  kkugel^.g:= 30;
  randomize;
  Dxdraw1.Cursor := crNone;
  player[4].pos := vektor(250,550);
  player[3].pos := vektor(0,550);
  player[5].pos := vektor(500,550);
  player[1].pos := vektor(250,0);
  player[0].pos := vektor(0,0);
  player[2].pos := vektor(500, 0);
end;

procedure TForm1.start;
var int1 : integer;
begin
  spielstart;
  listbox1.Clear;
  for int1 := 0 to 5 do listbox1.items.add(format('Player %d: %s',[int1,player[int1].name]));
  button3.enabled := false;
  button1.enabled := false;
  speedbutton1.enabled := true;
  DXTimer1.Enabled := true;
end;

procedure TForm1.Button1Click(Sender: TObject);
var int1: integer;
begin
  dxplay1.ProviderName := 'Internet TCP/IP-Verbindung fr DirectPlay';
  dxplay1.open2(true,'Singlep','Player');
  for int1 := 0 to 5 do with player[int1] do name := 'PC';
  ich := 4;
  player[4].name := 'Player';
  useki := true;
  start;
  DXWaveList1.items[3].Play(false);
end;

procedure TForm1.Button3Click(Sender: TObject);
var int1: integer;
    fertig: integer;
    msgstart : TstartData;
begin
   for int1 := 0 to 5 do player[int1].name := 'PC';
   try Dxplay1.Open;
   except showmessage('Verbindung fehlgeschlagen'); exit; end;
   fillchar(startlist,sizeof(startlist),0);
   startform.ListBox1.clear;
   if startform.showmodal <> mrok then exit;
   msgstart.MessageType := mStart;
   msgstart.rSeed := RandSeed;
   dxplay1.sendmessage(0,addr(msgstart),sizeof(msgstart));
   dxplay1.sendmessage(Dxplay1.LocalPlayer.ID,addr(msgstart),sizeof(msgstart));
   start;
   repeat
     fertig := 0;
     for int1 := 0 to 5 do if startlist[int1] then inc(fertig);
     dxdraw1.surface.fill(0);
     dxdraw1.surface.canvas.TextOut(170,260,format(' %d Spieler fertig',[fertig]));
     dxdraw1.surface.canvas.release;
     dxdraw1.flip;
     application.processmessages;
   until (fertig >= DXPlay1.Players.Count) or button3.enabled;
   if button3.enabled then exit;
   useki := false;
   DXWaveList1.items[3].Play(false);
   form1.caption := 'Kugelspiel ' + player[ich].name;
end;

procedure TForm1.draw;
var int1, int2 : integer;
begin
  Imagelist.Items[0].Draw(dxdraw1.surface,0,0,0);
  for int1 := 0 to maxk do if kugeln[int1].pos.x > -10 then
    Imagelist.Items[1].Draw(dxdraw1.surface,round(kugeln[int1].pos.x-kugeln[int1].radius),round(kugeln[int1].pos.y-kugeln[int1].radius),0);
  for int1 := 0 to 30 do with effekte[int1] do if zeit <> -1 then begin
    inc(zeit);
    case art of
      1: begin
           int2 := round(15 * (1-(zeit/gzeit)));
           Imagelist.Items[1].StretchDraw(dxdraw1.surface,rect(round(pos.x-int2),round(pos.y-int2),round(pos.x+int2),round(pos.y+int2)),0);
         end;
    end;
    if zeit >= gzeit then zeit := -1;
  end;
  Imagelist.Items[2].Draw(dxdraw1.surface,round(kkugel^.pos.x-kkugel^.radius),round(kkugel^.pos.y-kkugel^.radius),0);
  Imagelist.Items[3].Draw(dxdraw1.surface,mx-15,my-15,0);
  dxdraw1.flip;
  label6.Caption := inttostr(player[ich].hat);
end;

procedure TForm1.sendereignis(typ,_time:integer;ve:TVektor);
var PauseData : TPauseData;
    TakeData  : TTakeData;
    TrowData : TTrowData;
begin
  case typ of
    mPause : begin
              PauseData.MessageType := typ;
              PauseData.time := _time;
              dxplay1.sendmessage(0,addr(PauseData),sizeof(PauseData));
              dxplay1.sendmessage(dxplay1.LocalPlayer.ID,addr(PauseData),sizeof(PauseData));
             end;
    mTake : begin
              TakeData.MessageType := typ;
              TakeData.time := _time;
              TakeData.pos:=ve;
              dxplay1.sendmessage(0,addr(TakeData),sizeof(TakeData));
              dxplay1.sendmessage(dxplay1.LocalPlayer.ID,addr(TakeData),sizeof(TakeData));
             end;
    mTrow : begin
              TrowData.MessageType := typ;
              TrowData.time := _time;
              TrowData.pos:=ve;
              dxplay1.sendmessage(0,addr(TrowData),sizeof(TrowData));
              dxplay1.sendmessage(dxplay1.LocalPlayer.ID,addr(TrowData),sizeof(TrowData));
             end;
  end;
end;

procedure TForm1.ki(plnr: integer);
var int1 : integer;
    p1 : TVektor;
begin
  with player[plnr] do begin
    dec(wait);
    if wait < 0 then begin
      wait := starke;
      if hold <> [] then begin
        p1 := vadd(kkugel^.pos,vmul(kkugel^.speed,verz));
        if pos.y = 0 then p1.y := p1.y - kkugel^.radius else p1.y := p1.y + kkugel^.radius;
        createereignis(mTrow, plnr, szeit+verz, p1);
      end else begin
        for int1 := 0 to maxk do
          with kugeln[int1] do
            if (pos.x >-10) and (betrag(speed)<2) then begin
              createereignis(mTake, plnr, szeit+verz, vadd(pos,vmul(speed,verz)));
              exit;
            end;
      end;
    end;
  end;
end;

procedure sendping(an : integer);
var PingData : TPingData;
begin
  pingdata.MessageType := mping;
  pingdata.time := szeit+verz;
  pingdata.zeit := now;
  pingdata.von:= player[ich].name;
  form1.dxplay1.SendMessage(form1.dxplay1.Players.players[an].ID,addr(pingdata),sizeof(pingdata));
end;

procedure TForm1.pingit;
var int1 : integer;
begin
  if szeit - pzeit > 3 then begin
    for int1 := 0 to dxplay1.Players.Count-1 do sendping(int1);
    pzeit := szeit;
  end;
end;

procedure checktimeout;
var int1 : integer;
    z2 : double;
    er : PEreignis;
begin
  for int1 := 0 to 5 do
    with player[int1] do
      if (name <> 'PC') and (lastevent < szeit) then begin
        form1.memo1.lines.add('Sie haben die Verbindung zu einem Spieler verloren');
        er := ereignis;
        z2 := now;
        while (now < z2 + 1/(5*secsperday)) and (ereignis=er) do begin application.processmessages; end;
//        if ereignis = er then verz := round(verz * 1.1);
        form1.label9.caption:= 'Verzgerung '+inttostr(verz);
      end;
end;

procedure TForm1.DXTimer1Timer(Sender: TObject; LagCount: Integer);
var int1,int2: integer;
begin
  inc(szeit);
  ereignisstart;
  for int1 := 0 to maxk do movekugel(kugeln[int1]);
  movekugel(kkugel^);
  hitkugeln;
  pingit;
  checktimeout;
  if Application.Active then draw;
  if speedbutton1.down <> pause then begin
    speedbutton1.OnClick := nil;
    speedbutton1.down := pause;
    speedbutton1.OnClick := form1.speedbutton1click;
  end;
  if pause then exit;
  if useki then for int1 := 0 to 5 do if player[int1].name = 'PC' then ki(int1);
  if (checkbox1.Checked) and (player[ich].hold = []) then with player[ich] do begin
    dec(wait);
    if wait < 0 then begin
      wait := 20;
      for int2 := 0 to maxk do
        with kugeln[int2] do
          if (pos.x >-10) and (betrag(speed)<2.04) then begin
            sendereignis(mTake,szeit+verz,vadd(pos,vmul(speed,verz)));
            break;
          end;
    end;
  end;
end;

procedure TForm1.DXDraw1MouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
begin
  mx := x;
  my := y;
end;

procedure TForm1.DXDraw1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if pause or (not dxtimer1.enabled) then exit;
  if mbleft = Button then sendereignis(mTrow,szeit+verz,vektor(x,y));
  if mbright = Button then sendereignis(mTake,szeit+verz,vektor(x,y));
end;

procedure TForm1.Button2Click(Sender: TObject);
begin form1.close; end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
  sendereignis(mpause,szeit+verz,vektor(0,0));
end;

procedure TForm1.DXPlay1Open(Sender: TObject);
var int1 : Integer;
begin
  for int1 := 0 to DXPlay1.Players.Count-1 do
    if DXPlay1.Players[int1].RemotePlayer then
      startform.listbox1.Items.add(DXPlay1.Players[int1].Name);
end;

procedure TForm1.DXPlay1AddPlayer(Sender: TObject; _Player: TDXPlayPlayer);
var int1 : integer;
begin
  startform.ListBox1.Items.Add(_Player.Name);
  for int1 := 0 to 5 do
    if player[int1].name = 'PC' then begin player[int1].name := _Player.name; break; end;
  startform.sendplayer;
  startform.Repaint;
  if (startform.Visible = false) and _player.RemotePlayer then begin
    memo1.Lines.Add(format(' %s will einsteigen',[_player.name]));
  end;
end;

procedure TForm1.DXPlay1DeletePlayer(Sender: TObject; _Player: TDXPlayPlayer);
var int1 : integer;
begin
   startform.ListBox1.Items.delete(startform.ListBox1.Items.IndexOf(_Player.Name));
  int1 := 0;
  while (player[int1].name <> _player.name) and (int1 < 5) do inc(int1);
  player[int1].name := 'PC';
  if startform.Visible = false then begin
    memo1.Lines.Add(format(' %s hat Spiel verlassen',[_player.name]));
  end else begin
    startform.Repaint;
  end;
end;

procedure TForm1.DXPlay1Message(Sender: TObject; From: TDXPlayPlayer; Data: Pointer; DataSize: Integer);
var int1 : integer;
    PingData : TPingData;
begin
  int1 := findname(from.name);
  if DXPlayMessageType(Data) in [mTake,mTrow,mPing] then
    player[int1].lastevent := TPingData(data^).time;
  case DXPlayMessageType(Data) of
    mChangePlayer: begin
            for int1 := 0 to 5 do
              player[int1].name := TChangePlayerData(Data^).namen[int1];
            startform.paintbox1.repaint;
          end;
    mStart: begin
              startlist[int1]:=true;
              RandSeed := TStartData(Data^).rseed;
            end;
    mTake : with TTakeData(data^) do if not createereignis(mTake,int1,time,pos) then application.messagebox('TIMEOUT','',0);
    mTrow : with TTrowData(data^) do if not createereignis(mTrow,int1,time,pos) then application.messagebox('TIMEOUT','',0);
    mPause: with TPauseData(data^) do if not createereignis(mPause,int1,time,vektor(0,0)) then application.messagebox('TIMEOUT','',0);
    mPing : with TPingData(data^) do
                 if von = player[ich].name then begin
                   player[int1].ping := (now-zeit)*secsperday*1000;
                   listbox2.items[int1] := format('Ping: %f',[player[int1].ping]);
                 end else dxplay1.sendmessage(from.ID,data,datasize);
  end;
end;

procedure TForm1.Button4Click(Sender: TObject);
var er: Pereignis;
begin
  DXPlay1.Close;
  button3.enabled := true;
  button1.enabled := true;
  dxtimer1.enabled := false;
  while ereignis <> nil do begin
    er := ereignis^.next;
    dispose(ereignis);
    ereignis := er;
  end;
  dispose(ereignis);
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  DXPlay1.Close;
end;

end.
